import 'package:auth0_flutter2/auth0_flutter2.dart';
import 'package:flutter/material.dart';

void main() {
  Auth0Flutter2.auth0Domain = "AUTH0_DOMAIN";
  Auth0Flutter2.auth0ClientId = "AUTH0_CLIENT_ID";

  runApp(const MyApp());
}

class MyApp extends StatelessWidget {
  const MyApp({super.key});

  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Auth0Flutter2 Demo',
      theme: ThemeData(
        // This is the theme of your application.
        //
        // Try running your application with "flutter run". You'll see the
        // application has a blue toolbar. Then, without quitting the app, try
        // changing the primarySwatch below to Colors.green and then invoke
        // "hot reload" (press "r" in the console where you ran "flutter run",
        // or simply save your changes to "hot reload" in a Flutter IDE).
        // Notice that the counter didn't reset back to zero; the application
        // is not restarted.
        primarySwatch: Colors.deepPurple,
      ),
      home: const MyHomePage(),
    );
  }
}

class MyHomePage extends StatefulWidget {
  const MyHomePage({super.key});

  @override
  State<MyHomePage> createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  String _userId = "";

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: Center(
        child: Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: <Widget>[
            ElevatedButton(
              onPressed: () {
                Auth0Flutter2.instance.loginUser();
              },
              child: const Text(
                "Login User",
              ),
            ),
            const SizedBox(height: 8),
            ElevatedButton(
              onPressed: () {
                Auth0Flutter2.instance.logoutUser();
              },
              child: const Text(
                "Logout User",
              ),
            ),
            const SizedBox(height: 8),
            ElevatedButton(
              onPressed: () async {
                var userId = await Auth0Flutter2.instance.getLoggedInUserId();
                setState(() {
                  _userId = userId ?? "User Not Logged In";
                });
              },
              child: const Text(
                "Fetch Logged In UserId",
              ),
            ),
            const SizedBox(height: 20),
            Text(
              "Authenticated User ID: $_userId",
              textAlign: TextAlign.center,
              style: const TextStyle(
                fontWeight: FontWeight.bold,
              ),
            ),
          ],
        ),
      ),
    );
  }
}
